# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Tasks

* [`add_custom_facts`](#add_custom_facts): Add custom facts
* [`deactivate_nodes`](#deactivate_nodes): Deactivate nodes in PuppetDB
* [`get_certificate_request`](#get_certificate_request): Get the fingerprint of the certificate request of a Puppet node
* [`revoke_certificates`](#revoke_certificates): Revoke certificates on the Puppet Server
* [`set_puppet_config`](#set_puppet_config): Set Puppet configuration
* [`sign_certificate_requests`](#sign_certificate_requests): Sign certificate requests on the Puppet Server

### Plans

#### Private Plans

* `commission::commission`: Commission nodes and connect them to the Puppet infrastructure
* `commission::decommission`: Decommission nodes and disconnect them from the Puppet infrastructure

## Tasks

### <a name="add_custom_facts"></a>`add_custom_facts`

Add custom facts

**Supports noop?** false

#### Parameters

##### `custom_facts_dir`

Data type: `Optional[Stdlib::AbsolutePath]`

The directory of custom facts

##### `facts`

Data type: `Hash[String[1],Any]`

The facts to set

### <a name="deactivate_nodes"></a>`deactivate_nodes`

Deactivate nodes in PuppetDB

**Supports noop?** false

#### Parameters

##### `nodes`

Data type: `Array[String[1]]`

The nodes to deactivate

### <a name="get_certificate_request"></a>`get_certificate_request`

Get the fingerprint of the certificate request of a Puppet node

**Supports noop?** false

### <a name="revoke_certificates"></a>`revoke_certificates`

Revoke certificates on the Puppet Server

**Supports noop?** false

#### Parameters

##### `certificates`

Data type: `Array[String[1]]`

The certificates to revoke

### <a name="set_puppet_config"></a>`set_puppet_config`

Set Puppet configuration

**Supports noop?** false

#### Parameters

##### `settings`

Data type: `Hash[String[1],Any]`

The settings to set

### <a name="sign_certificate_requests"></a>`sign_certificate_requests`

Sign certificate requests on the Puppet Server

**Supports noop?** false

#### Parameters

##### `certificate_requests`

Data type: `Hash[String[1], Struct[{digest => String[1], fingerprint => String[1]}]]`

Attributes of the certificate requests to sign

